# Controlify 1.7.0 for 1.20.1

Updated to 1.20.2.

## Changes since 1.7.0-beta.3

### Bug Fixes

- Fix crash when sometimes opening chat screen, even without a controller (#186)

## New Features

- Added D-Pad snapping in container screens
- Keyboard-like movement whitelist and warning toast when joining new servers
- Added bind to open F3 debug screen
- More snap points on recipe book
- Allow users to define a custom SDL natives path (so you can put them in a common dir if you want)
- Add a reset all binds button to controls tab
- Added an SDL download screen that appears with a progress bar when downloading SDL2 for the first time or an update.

## Changes

- Switched to Java Native Access (JNA) from Java Native Interface (JNI) for SDL2 native library.
    - This should fix issues on Linux and macOS when loading SDL2.
    - This makes adding more features with SDL2 easier in the future.
- Provided `gamecontrollerdb.txt` to SDL and GLFW to (hopefully) improve controller compatibility.
- Controller calibration now detects triggers on joysticks. You must re-calibrate your controller for this to take effect.
- Internal changes to the way controllers are discovered, loaded and managed.
- `delegate_setup` config option has been renamed to `quiet_mode`.
- Pause screen's disconnect shortcut now focuses the button instead of clicking it.
- Add a donate button to the controller carousel screen.
- Modify how analogue inputs are processed whilst ingame or using the virtual mouse to make it feel more "circular"
- Marginally improve performance of Controlify by using optimized hashmaps.
- Pressing back button on server list now focuses on the back button.

## Bug Fixes

- Fix pressing F3-Esc crashing when a controller is active.
- Fix [Immediately Fast](https://modrinth.com/mod/immediatelyfast) compatibility causing extreme log spam.
- Fix generic XInput controllers being identified as 8BitDo an controller.
- Fix NullPointerException when opening radial menu with an invalid action bound.
- Fix crash when discovering controllers without SDL loaded.
- Fix crash when sometimes opening chat screen, even without a controller (#186)
